diff -ur snort-2.0.2/src/preprocessors/perf-flow.c snort-2.0.2-ipv6/src/preprocessors/perf-flow.c
--- snort-2.0.2/src/preprocessors/perf-flow.c	Tue Feb  4 17:27:04 2003
+++ snort-2.0.2-ipv6/src/preprocessors/perf-flow.c	Tue Sep 30 13:25:26 2003
@@ -1,5 +1,5 @@
 /*
-** $Id: perf-flow.c,v 1.2 2003/02/04 08:27:04 chris_reid Exp $
+** $Id: perf-flow.c,v 1.1.1.1 2003/09/30 04:25:26 abekatsu Exp $
 **
 ** perf-flow.c
 **
diff -ur snort-2.0.2/src/preprocessors/perf-flow.h snort-2.0.2-ipv6/src/preprocessors/perf-flow.h
--- snort-2.0.2/src/preprocessors/perf-flow.h	Fri Mar 14 17:28:54 2003
+++ snort-2.0.2-ipv6/src/preprocessors/perf-flow.h	Tue Sep 30 13:25:26 2003
@@ -1,4 +1,4 @@
-/* $Id: perf-flow.h,v 1.2 2003/03/14 08:28:54 chris_reid Exp $ */
+/* $Id: perf-flow.h,v 1.1.1.1 2003/09/30 04:25:26 abekatsu Exp $ */
 /*
 ** perf-flow.h
 **
diff -ur snort-2.0.2/src/preprocessors/perf.c snort-2.0.2-ipv6/src/preprocessors/perf.c
--- snort-2.0.2/src/preprocessors/perf.c	Thu Oct 10 14:05:58 2002
+++ snort-2.0.2-ipv6/src/preprocessors/perf.c	Tue Sep 30 13:25:26 2003
@@ -1,5 +1,5 @@
 /*
-**  $Id: perf.c,v 1.1 2002/10/10 05:05:58 chrisgreen Exp $
+**  $Id: perf.c,v 1.1.1.1 2003/09/30 04:25:26 abekatsu Exp $
 **
 **  perf.c
 **
diff -ur snort-2.0.2/src/preprocessors/perf.h snort-2.0.2-ipv6/src/preprocessors/perf.h
--- snort-2.0.2/src/preprocessors/perf.h	Tue Feb  4 17:27:04 2003
+++ snort-2.0.2-ipv6/src/preprocessors/perf.h	Tue Sep 30 13:25:26 2003
@@ -1,5 +1,5 @@
 /*
-** $Id: perf.h,v 1.2 2003/02/04 08:27:04 chris_reid Exp $
+** $Id: perf.h,v 1.1.1.1 2003/09/30 04:25:26 abekatsu Exp $
 **
 ** perf.h
 **
diff -ur snort-2.0.2/src/preprocessors/sfprocpidstats.c snort-2.0.2-ipv6/src/preprocessors/sfprocpidstats.c
--- snort-2.0.2/src/preprocessors/sfprocpidstats.c	Mon Jan  6 05:36:29 2003
+++ snort-2.0.2-ipv6/src/preprocessors/sfprocpidstats.c	Tue Sep 30 13:25:26 2003
@@ -1,5 +1,5 @@
 /*
-** $Id: sfprocpidstats.c,v 1.2 2003/01/05 20:36:29 cazz Exp $
+** $Id: sfprocpidstats.c,v 1.1.1.1 2003/09/30 04:25:26 abekatsu Exp $
 **
 **  sfprocpidstats.c
 **
diff -ur snort-2.0.2/src/preprocessors/sfprocpidstats.h snort-2.0.2-ipv6/src/preprocessors/sfprocpidstats.h
--- snort-2.0.2/src/preprocessors/sfprocpidstats.h	Mon Jan  6 05:36:29 2003
+++ snort-2.0.2-ipv6/src/preprocessors/sfprocpidstats.h	Tue Sep 30 13:25:26 2003
@@ -1,5 +1,5 @@
 /*
-** $Id: sfprocpidstats.h,v 1.2 2003/01/05 20:36:29 cazz Exp $
+** $Id: sfprocpidstats.h,v 1.1.1.1 2003/09/30 04:25:26 abekatsu Exp $
 **
 ** sfprocpidstats.h
 **
diff -ur snort-2.0.2/src/preprocessors/spp_arpspoof.c snort-2.0.2-ipv6/src/preprocessors/spp_arpspoof.c
--- snort-2.0.2/src/preprocessors/spp_arpspoof.c	Sat Jul 26 00:17:28 2003
+++ snort-2.0.2-ipv6/src/preprocessors/spp_arpspoof.c	Tue Sep 30 13:25:26 2003
@@ -1,4 +1,4 @@
-/* $Id: spp_arpspoof.c,v 1.20 2003/07/25 15:17:28 chrisgreen Exp $ */
+/* $Id: spp_arpspoof.c,v 1.1.1.1 2003/09/30 04:25:26 abekatsu Exp $ */
 /*
 ** Copyright (C) 2001-2003 Jeff Nathan <jeff@snort.org>
 **
diff -ur snort-2.0.2/src/preprocessors/spp_arpspoof.h snort-2.0.2-ipv6/src/preprocessors/spp_arpspoof.h
--- snort-2.0.2/src/preprocessors/spp_arpspoof.h	Sat Jul 26 00:17:28 2003
+++ snort-2.0.2-ipv6/src/preprocessors/spp_arpspoof.h	Tue Sep 30 13:25:26 2003
@@ -1,4 +1,4 @@
-/* $Id: spp_arpspoof.h,v 1.6 2003/07/25 15:17:28 chrisgreen Exp $ */
+/* $Id: spp_arpspoof.h,v 1.1.1.1 2003/09/30 04:25:26 abekatsu Exp $ */
 /*
 ** Copyright (C) 2001-2003 Jeff Nathan <jeff@snort.org>
 **
diff -ur snort-2.0.2/src/preprocessors/spp_bo.c snort-2.0.2-ipv6/src/preprocessors/spp_bo.c
--- snort-2.0.2/src/preprocessors/spp_bo.c	Thu Jun  5 04:32:20 2003
+++ snort-2.0.2-ipv6/src/preprocessors/spp_bo.c	Tue Sep 30 13:25:26 2003
@@ -16,7 +16,7 @@
 ** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
-/* $Id: spp_bo.c,v 1.16 2003/06/04 19:32:20 chrisgreen Exp $ */
+/* $Id: spp_bo.c,v 1.1.1.1 2003/09/30 04:25:26 abekatsu Exp $ */
 /* Snort Preprocessor Plugin Source File Bo */
 
 /* spp_bo 
diff -ur snort-2.0.2/src/preprocessors/spp_bo.h snort-2.0.2-ipv6/src/preprocessors/spp_bo.h
--- snort-2.0.2/src/preprocessors/spp_bo.h	Tue May 14 09:29:35 2002
+++ snort-2.0.2-ipv6/src/preprocessors/spp_bo.h	Tue Sep 30 13:25:26 2003
@@ -16,7 +16,7 @@
 ** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
-/* $Id: spp_bo.h,v 1.4 2002/05/14 00:29:35 chrisgreen Exp $ */
+/* $Id: spp_bo.h,v 1.1.1.1 2003/09/30 04:25:26 abekatsu Exp $ */
 /* Snort Back Orifice Preprocessor Plugin */
 
 
diff -ur snort-2.0.2/src/preprocessors/spp_conversation.c snort-2.0.2-ipv6/src/preprocessors/spp_conversation.c
--- snort-2.0.2/src/preprocessors/spp_conversation.c	Thu Mar 27 09:18:57 2003
+++ snort-2.0.2-ipv6/src/preprocessors/spp_conversation.c	Sat Nov 29 16:38:39 2003
@@ -1,5 +1,6 @@
 /*
 ** Copyright (C) 1998-2002 Martin Roesch <roesch@sourcefire.com>
+**               2003      Katsuhisa ABE <abekatsu@cysols.com>
 **
 ** This program is free software; you can redistribute it and/or modify
 ** it under the terms of the GNU General Public License as published by
@@ -16,7 +17,7 @@
 ** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
-/* $Id: spp_conversation.c,v 1.20 2003/03/27 00:18:57 chris_reid Exp $
+/* $Id: spp_conversation.c,v 1.2 2003/11/29 07:38:39 abekatsu Exp $
  *
  */
 
@@ -93,6 +94,7 @@
 static int ConvCompareFunc(ubi_trItemPtr ItemPtr, ubi_trNodePtr NodePtr);
 static int PruneConvCache(u_int32_t now, int tokill, StateRecord *keeper);
 static StateRecord* ConvGetSession(Packet* p);
+static INLINE int IpAddrCompare(Packet *p);
 static INLINE void FillStateRecord(StateRecord *s, Packet *p);
 static INLINE void FillConvStats(StateRecord *s, Packet *p);
 /****************************************
@@ -288,6 +290,8 @@
 void ConvFunc(Packet* p)
 {
     StateRecord* srecord;
+    u_int8_t protocol;
+    char src[INET6_ADDRSTRLEN], dst[INET6_ADDRSTRLEN];
 
     if(!(p->preprocessors & PP_CONVERSATION))
     {
@@ -303,7 +307,7 @@
         return;
     }
     
-    if (p->iph == NULL)
+    if (p->iph == NULL && p->ip6h == NULL)
     {
         DEBUG_WRAP(DebugMessage(DEBUG_CONVERSATION,
                                 "ignoring non-ip traffic\n"));
@@ -311,27 +315,41 @@
     }
 
     /* is this an allowed ip protocol */
-    if(conv_data.allowed_ip_protocols[p->iph->ip_proto] != 1)
+    if (p->iph != NULL)
     {
-        Event event;
+	protocol = p->iph->ip_proto;
+	(void) inet_ntop(PF_INET, &p->iph->ip_src, src, INET_ADDRSTRLEN);
+	(void) inet_ntop(PF_INET, &p->iph->ip_dst, dst, INET_ADDRSTRLEN);
+    }
+    else if (p->ip6h != NULL)
+    {
+	protocol = p->ip6h->s_ip6_nxt;
+	(void) inet_ntop(PF_INET6, &p->ip6h->ip6_src, src, INET6_ADDRSTRLEN);
+	(void) inet_ntop(PF_INET6, &p->ip6h->ip6_dst, dst, INET6_ADDRSTRLEN);
+    }
+
+
+    if(conv_data.allowed_ip_protocols[protocol] != 1)
+    {
+	Event event;
         
-        if(conv_data.alert_odd_protocols == 1)
-        {
-            SetEvent(&event, GENERATOR_SPP_CONV, 
-                     CONV_BAD_IP_PROTOCOL, 1, 0, 5, 0);
-            CallAlertFuncs(p, CONV_BAD_IP_PROTOCOL_STR, NULL, &event);
-            CallLogFuncs(p, CONV_BAD_IP_PROTOCOL_STR, NULL, &event);
-        }
+	if(conv_data.alert_odd_protocols == 1)
+	{
+	    SetEvent(&event, GENERATOR_SPP_CONV, 
+		     CONV_BAD_IP_PROTOCOL, 1, 0, 5, 0);
+	    CallAlertFuncs(p, CONV_BAD_IP_PROTOCOL_STR, NULL, &event);
+	    CallLogFuncs(p, CONV_BAD_IP_PROTOCOL_STR, NULL, &event);
+	}
         
-        return;
+	return;
     }
     
     DEBUG_WRAP(DebugMessage(DEBUG_CONVERSATION,
                             "_____________________________\n"
                             "%s:%u->",
-                            inet_ntoa(p->iph->ip_src), p->sp);
+                            src, p->sp);
                DebugMessage(DEBUG_CONVERSATION, "%s:%u\n",
-                            inet_ntoa(p->iph->ip_dst), p->dp););
+                            dst, p->dp););
 
 
     /* This will watch portscan watch */
@@ -382,12 +400,10 @@
         FillConvStats(srecord, p);
     }
 
-    
     /*
      * controls if we will watch for scans on new sessions with
      * spp_portscan2
      */
-
     if(conv_data.watch_scans && (!(srecord->conv_flags & CONV_MULIPACKETS)))
     {
         /* only call this if this is the first packet in a conversation */
@@ -465,7 +481,12 @@
  */ 
 static INLINE void FillConvStats(StateRecord *s, Packet *p)
 {
+
+#if HAVE_SOCKADDR_STORAGE
+    if(IpAddrCompare(p) == 1)
+#else
     if(PACKET_FORWARD(p))
+#endif
     {
         s->bytes_sent += p->caplen;
         s->dsize_sent += p->dsize;
@@ -483,15 +504,145 @@
 /***********************************************
  * Fills the state record with info
  ***********************************************/
+static INLINE int IpAddrCompare(Packet *p)
+{
+     if(p == NULL)
+	 return 0;
+
+     if(p->iph != NULL)
+     {
+	  if (*(u_int32_t *)&p->iph->ip_dst.s_addr > *(u_int32_t *)&p->iph->ip_src.s_addr )
+	      return 1;
+	  else if (*(u_int32_t *)&p->iph->ip_dst.s_addr == *(u_int32_t *)&p->iph->ip_src.s_addr)
+	      return 0;
+	  else
+	      return -1;
+     } 
+     else if (p->ip6h != NULL)
+     {
+	 int i;
+	 for (i = 0; i < 16 ; i++)
+	 {
+	      if (*(u_int8_t *)&p->ip6h->ip6_dst.s6_addr[i] > *(u_int8_t *)&p->ip6h->ip6_src.s6_addr[i])
+	      {
+		  return 1;
+	      }
+	      else if (*(u_int8_t *)&p->ip6h->ip6_dst.s6_addr[i] < *(u_int8_t *)&p->ip6h->ip6_src.s6_addr[i])
+	      {
+		  return -1;
+	      }
+	 }
+	 return 0;
+     }
+     return 0;
+}
 static INLINE void FillStateRecord(StateRecord* s, Packet* p)
 {
+#if HAVE_SOCKADDR_STORAGE
+    char srchost[INET6_ADDRSTRLEN], dsthost[INET6_ADDRSTRLEN];
+#endif
     /*
       always store things the same way so that when we have to look
       up a session, we only have to look them up one way.
     */
+    if (p->iph != NULL)
+	s->ip_proto = p->iph->ip_proto;
+    else if (p->ip6h != NULL)
+	s->ip_proto = p->ip6h->s_ip6_nxt;
+
+#if HAVE_SOCKADDR_STORAGE
+    if (IpAddrCompare(p) == 1) 
+    {
+        DEBUG_WRAP(DebugMessage(DEBUG_CONVERSATION,
+                                "going forward!\n"););
+	if (p->iph != NULL) 
+	{
+	     struct sockaddr_in *sin_src = (struct sockaddr_in *)&s->sip;
+	     struct sockaddr_in *sin_dst = (struct sockaddr_in *)&s->dip;
+
+	     sin_src->sin_family = PF_INET;
+	     sin_dst->sin_family = PF_INET;
+	     sin_src->sin_addr.s_addr = (u_int32_t) p->iph->ip_src.s_addr;
+	     sin_dst->sin_addr.s_addr = (u_int32_t) p->iph->ip_dst.s_addr;
+#if HAVE_SOCKADDR_STORAGE_SS_LEN
+	     s->sip.ss_len = sizeof(struct sockaddr_in);
+	     s->dip.ss_len = sizeof(struct sockaddr_in);
+#endif
 
-    s->ip_proto = p->iph->ip_proto;
+	     inet_ntop(PF_INET, (void *)&sin_src->sin_addr, srchost, INET_ADDRSTRLEN);
+	     inet_ntop(PF_INET, (void *)&sin_dst->sin_addr, dsthost, INET_ADDRSTRLEN);
+	}
+	else if (p->ip6h != NULL)
+	{
+	     struct sockaddr_in6 *sin6_src = (struct sockaddr_in6 *)&s->sip;
+	     struct sockaddr_in6 *sin6_dst = (struct sockaddr_in6 *)&s->dip;
+
+	     sin6_src->sin6_family = PF_INET6;
+	     sin6_dst->sin6_family = PF_INET6;
+	     memmove(&sin6_src->sin6_addr, &p->ip6h->ip6_src, sizeof(struct in6_addr));
+	     memmove(&sin6_dst->sin6_addr, &p->ip6h->ip6_dst, sizeof(struct in6_addr));
+#if HAVE_SOCKADDR_STORAGE_SS_LEN
+	     s->sip.ss_len = sizeof(struct sockaddr_in6);
+	     s->dip.ss_len = sizeof(struct sockaddr_in6);
+#endif
 
+	     inet_ntop(PF_INET6, (void *)&sin6_src->sin6_addr, srchost, INET6_ADDRSTRLEN);
+	     inet_ntop(PF_INET6, (void *)&sin6_dst->sin6_addr, dsthost, INET6_ADDRSTRLEN);
+	}
+        s->sport = p->sp;
+        s->dport = p->dp;
+    } 
+    else
+    {
+        DEBUG_WRAP(DebugMessage(DEBUG_CONVERSATION,
+                                "going switcheroo ninja style!\n"););
+	if (p->iph != NULL) 
+	{
+	     struct sockaddr_in *sin_src = (struct sockaddr_in *)&s->dip;
+	     struct sockaddr_in *sin_dst = (struct sockaddr_in *)&s->sip;
+
+
+	     sin_src->sin_family = PF_INET;
+	     sin_dst->sin_family = PF_INET;
+	     sin_src->sin_addr.s_addr = (u_int32_t) p->iph->ip_src.s_addr;
+	     sin_dst->sin_addr.s_addr = (u_int32_t) p->iph->ip_dst.s_addr;
+#if HAVE_SOCKADDR_STORAGE_SS_LEN
+	     s->sip.ss_len = sizeof(struct sockaddr_in);
+	     s->dip.ss_len = sizeof(struct sockaddr_in);
+#endif
+
+	     inet_ntop(PF_INET, (void *)&sin_src->sin_addr, srchost, INET_ADDRSTRLEN);
+	     inet_ntop(PF_INET, (void *)&sin_dst->sin_addr, dsthost, INET_ADDRSTRLEN);
+	}
+	else if (p->ip6h != NULL)
+	{
+	     struct sockaddr_in6 *sin6_src = (struct sockaddr_in6 *)&s->dip;
+	     struct sockaddr_in6 *sin6_dst = (struct sockaddr_in6 *)&s->sip;
+
+	     sin6_src->sin6_family = PF_INET6;
+	     sin6_dst->sin6_family = PF_INET6;
+	     memmove(&sin6_src->sin6_addr, &p->ip6h->ip6_src, sizeof(struct in6_addr));
+	     memmove(&sin6_dst->sin6_addr, &p->ip6h->ip6_dst, sizeof(struct in6_addr));
+#if HAVE_SOCKADDR_STORAGE_SS_LEN
+	     s->sip.ss_len = sizeof(struct sockaddr_in6);
+	     s->dip.ss_len = sizeof(struct sockaddr_in6);
+#endif
+
+	     inet_ntop(PF_INET6, (void *)&sin6_src->sin6_addr, srchost, INET6_ADDRSTRLEN);
+	     inet_ntop(PF_INET6, (void *)&sin6_dst->sin6_addr, dsthost, INET6_ADDRSTRLEN);
+	}
+        s->sport = p->dp;
+        s->dport = p->sp;
+
+    }
+    DEBUG_WRAP(DebugMessage(DEBUG_CONVERSATION,
+                            "s->sip: %s, s->dip: %s "
+                            "s->sport: %d s->dport: %d s->ip_proto: %d\n",
+                            srchost, dsthost, s->sport, s->dport,s->ip_proto););
+#ifdef DEBUG
+    printf("(conversation) s->sip: %s, s->dip: %s, s->sport: %d s->dport: %d s->ip_proto: %d\n", srchost, dsthost, s->sport, s->dport, s->ip_proto);
+#endif /* DEBUG */
+#else
     if(PACKET_FORWARD(p))
     {
         DEBUG_WRAP(DebugMessage(DEBUG_CONVERSATION,
@@ -510,7 +661,6 @@
         s->sport = p->dp;
         s->dport = p->sp;
     }
-
     DEBUG_WRAP(DebugMessage(DEBUG_CONVERSATION,
                             "s->sip: %X, s->dip: %X "
                             "s->sport: %d s->dport: %d s->ip_proto: %d\n",
@@ -522,8 +672,7 @@
                             (u_int32_t) p->iph->ip_src.s_addr,
                             (u_int32_t) p->iph->ip_dst.s_addr,
                             p->sp,p->dp,p->iph->ip_proto););
-
-
+#endif
 }
 
 
@@ -545,16 +694,18 @@
 
     /* Searches it's own junk */
     FillStateRecord(&tmp, p);
-    DEBUG_WRAP(DebugMessage(DEBUG_CONVERSATION,
-                            "tmp.sip: %X, tmp.dip: %X "
-                            "tmp.sport: %d tmp.dport: %d tmp.ip_proto: %d\n",
-                            tmp.sip, tmp.dip, tmp.sport,tmp.dport,tmp.ip_proto););
 
-    
+
+    /* DEBUG_WRAP(DebugMessage(DEBUG_CONVERSATION,
+     *                     "tmp.sip: %X, tmp.dip: %X "
+     *                      "tmp.sport: %d tmp.dport: %d tmp.ip_proto: %d\n",
+     *                      tmp.sip, tmp.dip, tmp.sport,tmp.dport,tmp.ip_proto););
+     */
     
     ret = (StateRecord *) ubi_sptFind(conv_data.cachePtr,
                                       (ubi_btItemPtr) &tmp);
 
+
     DEBUG_WRAP(DebugMessage(DEBUG_CONVERSATION,
                             "ret from the sptFind is %p\n", ret););
   
@@ -603,8 +754,12 @@
 	 * always declared to be "sip".  This flag check allows us to
 	 * know who was the first talker.
 	 */
-        
+
+#if HAVE_SOCKADDR_STORAGE
+        if(IpAddrCompare(p) == 1)
+#else
         if(PACKET_FORWARD(p))
+#endif
         {
             ret->conv_flags |= CONV_FORWARD;
         }
@@ -613,12 +768,12 @@
             ret->conv_flags |= CONV_REVERSED;
         }
 
+
     }
     else /* ret != NULL */
     {
         DEBUG_WRAP(DebugMessage(DEBUG_CONVERSATION,
                                 "Conversation found @ %p\n", ret););
-
         ret->conv_flags |= CONV_MULIPACKETS;
     }
     
@@ -633,7 +788,42 @@
     StateRecord *A = (StateRecord *) ItemPtr;
     StateRecord *B = (StateRecord *) NodePtr;
 #ifdef DEBUG
+    char sip[INET6_ADDRSTRLEN], dip[INET6_ADDRSTRLEN];
+
+    switch(A->sip.ss_family)
+    {
+    case PF_INET:
+	inet_ntop(PF_INET, &((struct sockaddr_in *)&A->sip)->sin_addr,
+		  sip, INET_ADDRSTRLEN);
+	inet_ntop(PF_INET, &((struct sockaddr_in *)&A->dip)->sin_addr,
+		  dip, INET_ADDRSTRLEN);
+	printf("(portscan2 debug) A %s:%d -> %s:%d\n",
+	       sip, A->sport, dip, A->dport);
+	inet_ntop(PF_INET, &((struct sockaddr_in *)&B->sip)->sin_addr,
+		  sip, INET_ADDRSTRLEN);
+	inet_ntop(PF_INET, &((struct sockaddr_in *)&B->dip)->sin_addr,
+		  dip, INET_ADDRSTRLEN);
+	printf("(portscan2 debug) B %s:%d -> %s:%d\n",
+	       sip, B->sport, dip, B->dport);
+	break;
+    case PF_INET6:
+	inet_ntop(PF_INET6, &((struct sockaddr_in6 *)&A->sip)->sin6_addr,
+		  sip, INET6_ADDRSTRLEN);
+	inet_ntop(PF_INET6, &((struct sockaddr_in6 *)&A->dip)->sin6_addr,
+		  dip, INET6_ADDRSTRLEN);
+	printf("(portscan2 debug) A %s:%d -> %s:%d\n",
+	       sip, A->sport, dip, A->dport);
+	inet_ntop(PF_INET6, &((struct sockaddr_in6 *)&B->sip)->sin6_addr,
+		  sip, INET6_ADDRSTRLEN);
+	inet_ntop(PF_INET6, &((struct sockaddr_in6 *)&B->dip)->sin6_addr,
+		  dip, INET6_ADDRSTRLEN);
+	printf("(portscan2 debug) B %s:%d -> %s:%d\n",
+	       sip, B->sport, dip, B->dport);
+	break;	 
+    }
+#endif /* DEBUG */
 
+#ifdef DEBUG
     #define IPLEN 256
     char sip[IPLEN];
 
@@ -656,8 +846,31 @@
     #undef IPLEN
 #endif /* DEBUG */
 
-    
+#if HAVE_SOCKADDR_STORAGE
+    if (IpAddrComp (&A->sip, &B->sip) == -1)
+    {
+        DEBUG_WRAP(DebugMessage(DEBUG_CONVERSATION,"returning 1\n"););
+        return 1;
+    }
+
+    if (IpAddrComp (&A->sip, &B->sip) == 1)
+    {
+        DEBUG_WRAP(DebugMessage(DEBUG_CONVERSATION,"returning -1\n"););
+        return -1;
+    }
+
+    if (IpAddrComp (&A->dip, &B->dip) == -1)
+    {
+        DEBUG_WRAP(DebugMessage(DEBUG_CONVERSATION,"returning 1\n"););
+        return 1;
+    }
 
+    if (IpAddrComp (&A->dip, &B->dip) == 1)
+    {
+        DEBUG_WRAP(DebugMessage(DEBUG_CONVERSATION,"returning -1\n"););
+        return -1;
+    }
+#else    
     if(A->sip > B->sip)
     {
         DEBUG_WRAP(DebugMessage(DEBUG_CONVERSATION,"returning 1\n"););
@@ -682,7 +895,7 @@
         DEBUG_WRAP(DebugMessage(DEBUG_CONVERSATION,"returning -1\n"););
         return -1;
     }
-    
+#endif
     /* ok the IPs are equal */
     if(A->sport > B->sport)
     {
diff -ur snort-2.0.2/src/preprocessors/spp_conversation.h snort-2.0.2-ipv6/src/preprocessors/spp_conversation.h
--- snort-2.0.2/src/preprocessors/spp_conversation.h	Fri Mar 14 17:28:54 2003
+++ snort-2.0.2-ipv6/src/preprocessors/spp_conversation.h	Sat Nov 29 16:38:39 2003
@@ -1,4 +1,4 @@
-/* $Id: spp_conversation.h,v 1.10 2003/03/14 08:28:54 chris_reid Exp $ */
+/* $Id: spp_conversation.h,v 1.2 2003/11/29 07:38:39 abekatsu Exp $ */
 /*
 ** Copyright (C) 1998-2002 Martin Roesch <roesch@sourcefire.com>
 **
@@ -43,9 +43,13 @@
     ubi_trNode Node; /* used for ubi_ */
     MemBucket *bucket; /* the container that we are in */
 
-
+#if HAVE_SOCKADDR_STORAGE
+    struct sockaddr_storage sip;
+    struct sockaddr_storage dip;
+#else
     u_int32_t sip;
     u_int32_t dip;
+#endif
     unsigned short sport;
     unsigned short dport;
     unsigned char ip_proto;  
diff -ur snort-2.0.2/src/preprocessors/spp_frag2.c snort-2.0.2-ipv6/src/preprocessors/spp_frag2.c
--- snort-2.0.2/src/preprocessors/spp_frag2.c	Wed Jul 23 03:24:51 2003
+++ snort-2.0.2-ipv6/src/preprocessors/spp_frag2.c	Tue Sep 30 13:25:26 2003
@@ -1,4 +1,4 @@
-/* $Id: spp_frag2.c,v 1.62 2003/07/22 18:24:51 chrisgreen Exp $ */
+/* $Id: spp_frag2.c,v 1.1.1.1 2003/09/30 04:25:26 abekatsu Exp $ */
 /*
 ** Copyright (C) 1998-2002 Martin Roesch <roesch@sourcefire.com>
 **
diff -ur snort-2.0.2/src/preprocessors/spp_frag2.h snort-2.0.2-ipv6/src/preprocessors/spp_frag2.h
--- snort-2.0.2/src/preprocessors/spp_frag2.h	Thu Oct 10 14:05:58 2002
+++ snort-2.0.2-ipv6/src/preprocessors/spp_frag2.h	Tue Sep 30 13:25:26 2003
@@ -1,4 +1,4 @@
-/* $Id: spp_frag2.h,v 1.5 2002/10/10 05:05:58 chrisgreen Exp $ */
+/* $Id: spp_frag2.h,v 1.1.1.1 2003/09/30 04:25:26 abekatsu Exp $ */
 
 /*
 ** Copyright (C) 1998-2002 Martin Roesch <roesch@sourcefire.com>
diff -ur snort-2.0.2/src/preprocessors/spp_http_decode.c snort-2.0.2-ipv6/src/preprocessors/spp_http_decode.c
--- snort-2.0.2/src/preprocessors/spp_http_decode.c	Thu Mar 27 06:59:47 2003
+++ snort-2.0.2-ipv6/src/preprocessors/spp_http_decode.c	Thu Nov 20 14:28:57 2003
@@ -5,6 +5,8 @@
 ** Copyright (C) 2002 Rain Forest Puppy <rfp@wiretrip.net>
 ** Copyright (C) 2002 Sourcefire, Inc.
 **                    Daniel Roelker <droelker@sourcefire.com>
+** Copyright (C) 2003 Cyber Solutions Inc.
+**                    Katsuhisa ABE <abekatsu@cysols.com>
 **
 ** 11.1.02 (DJR): Fixed off-by bugs.  Fixed %25 encoding.  Fixed
 **                %u encoding for ascii codepoints.
@@ -23,7 +25,7 @@
 ** along with this program; if not, write to the Free Software
 ** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 **
-** $Id: spp_http_decode.c,v 1.56 2003/03/26 21:59:47 chrisgreen Exp $
+** $Id: spp_http_decode.c,v 1.1.1.1 2003/09/30 04:25:26 abekatsu Exp $
 */
 
 #ifdef HAVE_CONFIG_H
diff -ur snort-2.0.2/src/preprocessors/spp_http_decode.h snort-2.0.2-ipv6/src/preprocessors/spp_http_decode.h
--- snort-2.0.2/src/preprocessors/spp_http_decode.h	Thu Oct 10 14:05:59 2002
+++ snort-2.0.2-ipv6/src/preprocessors/spp_http_decode.h	Tue Sep 30 13:25:26 2003
@@ -16,7 +16,7 @@
 ** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
-/* $Id: spp_http_decode.h,v 1.7 2002/10/10 05:05:59 chrisgreen Exp $ */
+/* $Id: spp_http_decode.h,v 1.1.1.1 2003/09/30 04:25:26 abekatsu Exp $ */
 #include "snort.h"
 
 #ifndef __SPP_HTTP_DECODE_H__
diff -ur snort-2.0.2/src/preprocessors/spp_httpflow.c snort-2.0.2-ipv6/src/preprocessors/spp_httpflow.c
--- snort-2.0.2/src/preprocessors/spp_httpflow.c	Thu Oct 31 04:18:42 2002
+++ snort-2.0.2-ipv6/src/preprocessors/spp_httpflow.c	Tue Sep 30 13:25:26 2003
@@ -1,4 +1,4 @@
-/* $Id: spp_httpflow.c,v 1.2 2002/10/30 19:18:42 andrewbaker Exp $ 
+/* $Id: spp_httpflow.c,v 1.1.1.1 2003/09/30 04:25:26 abekatsu Exp $ 
 **
 **  spp_httpflow.c
 **
diff -ur snort-2.0.2/src/preprocessors/spp_httpflow.h snort-2.0.2-ipv6/src/preprocessors/spp_httpflow.h
--- snort-2.0.2/src/preprocessors/spp_httpflow.h	Thu Oct 10 14:05:59 2002
+++ snort-2.0.2-ipv6/src/preprocessors/spp_httpflow.h	Tue Sep 30 13:25:26 2003
@@ -1,4 +1,4 @@
-/* $Id: spp_httpflow.h,v 1.1 2002/10/10 05:05:59 chrisgreen Exp $
+/* $Id: spp_httpflow.h,v 1.1.1.1 2003/09/30 04:25:26 abekatsu Exp $
 **
 **  spp_httpflow.h
 **
diff -ur snort-2.0.2/src/preprocessors/spp_perfmonitor.c snort-2.0.2-ipv6/src/preprocessors/spp_perfmonitor.c
--- snort-2.0.2/src/preprocessors/spp_perfmonitor.c	Sat Jan 18 01:49:10 2003
+++ snort-2.0.2-ipv6/src/preprocessors/spp_perfmonitor.c	Tue Sep 30 13:25:26 2003
@@ -1,4 +1,4 @@
-/* $Id: spp_perfmonitor.c,v 1.4 2003/01/17 16:49:10 droelker Exp $ 
+/* $Id: spp_perfmonitor.c,v 1.1.1.1 2003/09/30 04:25:26 abekatsu Exp $ 
 **
 **  spp_perfmonitor.c
 **
diff -ur snort-2.0.2/src/preprocessors/spp_perfmonitor.h snort-2.0.2-ipv6/src/preprocessors/spp_perfmonitor.h
--- snort-2.0.2/src/preprocessors/spp_perfmonitor.h	Thu Oct 10 14:05:59 2002
+++ snort-2.0.2-ipv6/src/preprocessors/spp_perfmonitor.h	Tue Sep 30 13:25:26 2003
@@ -1,4 +1,4 @@
-/* $Id: spp_perfmonitor.h,v 1.2 2002/10/10 05:05:59 chrisgreen Exp $
+/* $Id: spp_perfmonitor.h,v 1.1.1.1 2003/09/30 04:25:26 abekatsu Exp $
 **
 **  spp_perfmonitor.h
 **
diff -ur snort-2.0.2/src/preprocessors/spp_portscan.c snort-2.0.2-ipv6/src/preprocessors/spp_portscan.c
--- snort-2.0.2/src/preprocessors/spp_portscan.c	Thu Mar 27 06:59:48 2003
+++ snort-2.0.2-ipv6/src/preprocessors/spp_portscan.c	Tue Sep 30 13:25:26 2003
@@ -17,7 +17,7 @@
 ** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
-/* $Id: spp_portscan.c,v 1.45 2003/03/26 21:59:48 chrisgreen Exp $ */
+/* $Id: spp_portscan.c,v 1.1.1.1 2003/09/30 04:25:26 abekatsu Exp $ */
 /* Snort Portscan Preprocessor Plugin
     by Patrick Mullen <p_mullen@linuxrc.net>
     Version 0.2.14
diff -ur snort-2.0.2/src/preprocessors/spp_portscan.h snort-2.0.2-ipv6/src/preprocessors/spp_portscan.h
--- snort-2.0.2/src/preprocessors/spp_portscan.h	Fri Mar 14 17:28:55 2003
+++ snort-2.0.2-ipv6/src/preprocessors/spp_portscan.h	Tue Sep 30 13:25:26 2003
@@ -1,4 +1,4 @@
-/* $Id: spp_portscan.h,v 1.8 2003/03/14 08:28:55 chris_reid Exp $ */
+/* $Id: spp_portscan.h,v 1.1.1.1 2003/09/30 04:25:26 abekatsu Exp $ */
 /*
 ** Copyright (C) 1998-2002 Martin Roesch <roesch@sourcefire.com>
 ** Copyright (C) 1999,2000,2001 Patrick Mullen <p_mullen@hotmail.com>
